Bug 463341 - Don't use unnecessary buggy-repeat fallbacks.
Don't use unnecessary buggy-repeat fallbacks.
Product: Fedora
Classification: Fedora
Component: firefox (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Martin Stransky
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2008-09-22 18:53 EDT by Owen Taylor
Modified: 2008-09-25 02:46 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-09-25 02:46:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Owen Taylor 2008-09-22 18:53:34 EDT
The Firefox version of cairo unconditionally turns on a "buggy-repeat"
fallback in Cairo that does tiled repeating images by grabbing everything
to the client, doing the repeat in software, then pushing the result
back. This can be extremely slow.

(It may be even slower with the kernel modesetting drivers that we are using in Fedora 10, but it is always going to be really slow.)

It's not completely clear what X server bug was being worked around, but
it doesn't seem to be present in recent X servers, like the Fedora X
server. Quoting from IRC:

<vlad_> try running with MOZ_CAIRO_NO_BUGGY_REPEAT=1 in the environment
<vlad_> we unconditionally force buggy repeat handling because we couldn't figure out a good heuristic to determine which x servers/drivers had the buggy code
<vlad_> so when we last looked at it, the bug existed in and seemed to be gone in at least xorg
<vlad_> so what we could do is disable that forcing for > 1.4 (or 1.5, whatever the latest is)
<vlad_> otaylor: filed https://bugzilla.mozilla.org/show_bug.cgi?id=456467

We should make sure that we have this fallback off for F10, either by pulling an upstream patch, by setting the environment variable, or by some either means.

One test case of this is header of http://www.smh.com.au , but it probably will be triggered on many web pages.
Comment 2 Martin Stransky 2008-09-23 08:54:56 EDT
I can handle it.
Comment 3 Martin Stransky 2008-09-24 05:18:32 EDT
It does not affect Fedora because we use system cairo there and it does not contain the original (broken) hack. The affected systems are RHEL-4/5 only.
Comment 4 Owen Taylor 2008-09-24 08:48:25 EDT
The Rawhide Firefox is not using the system cairo, even if it is intended to.
Comment 5 Martin Stransky 2008-09-25 02:46:20 EDT
okay, let's enable it then. added to xulrunner-

Note You need to log in before you can comment on or make changes to this bug.